#!/usr/bin/perl -w
foreach $crf (`ls out/*.crf*`) {
    $crf =~ /\/(.*)\.crf/;
    my $base = "$1.B";
    my $dat;
    my $br0;
    foreach $log (`ls out/`) {
        chomp $log;
        $log =~ /cme1/ and next;
        $log =~ /$base/ or next;
        $log = "out/$log";
        `tail $log` =~ /Global:([0-9.]+) kb\/s:([0-9.]+).*?^([0-9.]+)user/ms or warn "$log" and next;
        my ($psnr, $br, $time) = ($1,$2,$3);
        $br0 ||= int($br+.5);
        $dat .= "$time " . sprintf("%.3f", $psnr-($br/$br0-1)*5);
        $log =~ /_(m\d.*mix\d)/;
        $dat .= " $1\n";
    }
    $base =~ s/_\d+x\d+//;
    $base =~ s/\.B//;
    open OUT, ">", "$base.dat";
    print OUT $dat;
    close OUT;
}

# notes:
# for Hpii, cpu-time varied by about +/- .02 sec between runs of identical options
