#!/usr/bin/perl -w

close STDERR;

%A = ( 0=>'none', 1=>'i4x4', 3=>'i4x4,i8x8 -8', 10=>'p8x8', 11=>'i4x4,p8x8',
       13=>'i4x4,i8x8,p8x8 -8', 111=>'i4x4,p8x8,b8x8',
       113=>'i4x4,i8x8,p8x8,b8x8 -8', 133=>'all -8' );
@me = ( undef, 'dia', 'hex', 'umh' );
@brd = ( '', '--b-rdo' );
@cme = ( '--no-chroma-me', '' );
@mix = ( '', '--mixed-refs' );

$b=1;
$ba=0;
$sc=-1;
foreach $yuv (`ls in/*yuv`) {
    chomp $yuv;
    my ($base) = ($yuv =~ /\/(.*)\.yuv/g) or die;

    system "cat $yuv > /dev/null" for 0..3;

    my $opt = "$yuv -o/dev/null -v -b$b --scenecut=$sc" . ($ba?"":" --no-b-adapt");
    my $crf_log = "out/$base.crf24.log";
    if(!(-e $crf_log) or `cat $crf_log` !~ / kb\/s:(\d+)\./) {
        system "./x264-498 $opt --crf 24 &> $crf_log";
    }
    `cat $crf_log` =~ / kb\/s:(\d+)\./ or die;
    $B = $1;
    $opt .= " -B$B --vbv-bufsize=$B";

    my @cmds;

foreach $m  (1..7) {
foreach $r  (1,2,3,4,6) {
foreach $A  (0,1,3,10,11,13,111,113,133) { # also controls 8x8dct
foreach $me (1..3) {
foreach $t  (0..2) {
foreach $brd (0,1) {
foreach $cme (0) { #1
foreach $mix (0,1) {

    #these combos are invalid
    next if $t==2 && $m<6;
    next if $brd && ($m<6 || !$b);
    next if $cme && $m<5;
    next if $mix && ($r==1 || $A<10);
    #these combos are stupid
    next if (($A==133) && $m<5);
    next if (($A<113) && $m==7);
    next if (($A<111) && $m==6);
    next if (($A<11) && $m==5);
    next if (($r>2 || $me==3) && ($m<3 || $A<11));
    next if ($r>4 && !$mix);

    my $out = "out/$base.B${B}_b${b}:${ba}:${sc}_m${m}_r${r}_A${A}_t${t}_me${me}_brd${brd}_cme${cme}_mix${mix}";
    $out =~ s/A(\d_)/A00$1/;
    $out =~ s/A(\d\d_)/A0$1/;

    my $opt_new = "-m$m -r$r -t$t --me=$me[$me] -A=$A{$A} $mix[$mix] $brd[$brd] $cme[$cme]";
    $opt_new =~ s/  +/ /g;
    my $cmd = "./x264-498 $opt $opt_new";
    push @cmds, "(echo $cmd ; time $cmd) &> $out.log && chmod -w $out.log";
#   print "$opt_new\n";
}}}}}}}}

    my @msort;
    foreach $m (1..7) {
        push @msort, shuffle(grep {/_m$m/} @cmds);
    }
    my $n=0;
    foreach $cmd (@msort) {
        system $cmd;
        print ++$n, "/", $#cmds+1, " \r";
    }
    print "          \r";
}


sub shuffle {
    my @x;
    while(@_) {
        push @x, splice @_, int(rand($#_+1)), 1;
    }
    return @x;
}
